/* $Header: /ext/yav/catty/xpx/RCS/ellipse.c,v 1.1 1994/04/01 17:44:38 yav Exp $
 * Special thanks :
 * Algorithm dictionary by Haruhiko Okumura (PAF01002@niftyserve.or.jp)
 */

#define DOT(x,y) (*pp++ = (x), *pp++ = (y))

ellipse(pp, xc, yc, rx, ry)
     int *pp;
{
  int x, x1, y, y1, r, pts;

  pts = y = 0;
  if (rx > ry) {
    x = r = rx;
    while (x >= y) {
      x1 = ((long)x * ry) / rx;
      y1 = ((long)y * ry) / rx;
      DOT(xc + x, yc + y1);
      DOT(xc + x, yc - y1);
      DOT(xc - x, yc + y1);
      DOT(xc - x, yc - y1);
      DOT(xc + y, yc + x1);
      DOT(xc + y, yc - x1);
      DOT(xc - y, yc + x1);
      DOT(xc - y, yc - x1);
      pts += 8;
      if ((r -= (y++ << 1) - 1) < 0)
	r += (x-- - 1) << 1;
    }
  } else {
    x = r = ry;
    while (x >= y) {
      x1 = ((long)x * rx) / ry;
      y1 = ((long)y * rx) / ry;
      DOT(xc + x1, yc + y);
      DOT(xc + x1, yc - y);
      DOT(xc - x1, yc + y);
      DOT(xc - x1, yc - y);
      DOT(xc + y1, yc + x);
      DOT(xc + y1, yc - x);
      DOT(xc - y1, yc + x);
      DOT(xc - y1, yc - x);
      pts += 8;
      if ((r -= (y++ << 1) - 1) < 0)
	r += (x-- - 1) << 1;
    }
  }
  return pts;
}

/* End of file */
