/* $Header: /ext/yav/catty/xpx/RCS/cursor.c,v 1.10 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "cursdef.h"

#define CURSW	36
#define CURSH	18

char *curs_strfunc(p)
     MENU *p;
{
  int i;
  
  switch(p->n) {
  case CURS_TOPX:
    i = imgofsx;
    break;
  case CURS_TOPY:
    i = imgofsy;
    break;
  case CURS_CURX:
    i = curx;
    break;
  case CURS_CURY:
    i = cury;
    break;
  }
  sprintf(p->str, "%d", i);
  return p->str;
}

MENU cursmenu[] = {
  {
    CURS_TOPX,	MenuModeMaskBorder,
    0, 0, CURSW, CURSH,
    0, ExposureMask, 0,
    NULL, curs_strfunc, 0, 8, NULL},
  {
    CURS_TOPY,	MenuModeMaskBorder,
    CURSW+BDW, 0, CURSW, CURSH,
    0, ExposureMask, 0,
    NULL, curs_strfunc, 0, 8, NULL},
  {
    CURS_CURX,	MenuModeMaskBorder,
    (CURSW+BDW)*2, 0, CURSW, CURSH,
    0, ExposureMask, 0,
    NULL, curs_strfunc, 0, 8, NULL},
  {
    CURS_CURY,	MenuModeMaskBorder,
    (CURSW+BDW)*3, 0, CURSW, CURSH,
    0, ExposureMask, 0,
    NULL, curs_strfunc, 0, 8, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

create_cursor_window(x, y)
{
  menuwin_create(cursmenu, win, x, y);
}

/* End of file */
