/* $Header: /ext/yav/catty/xpx/RCS/line.c,v 1.1 1994/04/01 17:44:27 yav Exp $
 * Special thanks :
 * Algorithm dictionary by Haruhiko Okumura (PAF01002@niftyserve.or.jp)
 */

#define DOT(x,y) (*pp++ = (x), *pp++ = (y))

line(pp, x1, y1, x2, y2)
     int *pp;
{
  int dx, dy, s, ystep, xstep, cnt;
  
  dx = abs(x2 - x1);  dy = abs(y2 - y1);
  xstep = (x1 < x2) ? 1: -1;
  ystep = (y1 < y2) ? 1: -1;
  if (dx > dy) {
    s = dx >> 1;
    cnt = dx+1;
    do {
      DOT(x1, y1);
      if ((s -= dy) < 0) {
	s += dx;  y1 += ystep;
      };
      x1 += xstep;
    } while (--cnt);
    return dx+1;
  } else {
    s = dy >> 1;
    cnt = dy+1;
    do {
      DOT(x1, y1);
      if ((s -= dx) < 0) {
	s += dy;  x1 += xstep;
      }
      y1 += ystep;
    } while (--cnt);
    return dy+1;
  }
}

/* End of file */
