/* $Header: /ext/yav/catty/xpx/RCS/undo.c,v 1.1 1994/03/22 13:45:13 yav Exp $
 */

#include <stdio.h>

static char *undo_buf = NULL;
static int undo_buf_size = 128;
static int undo_ptr = 0;

typedef struct {
  int cmd;
  int size;
} UNDOST;

#define UNDO_MARK 0

undo_init()
{
  undo_ptr = 0;
  undo_buf = (char *)malloc(undo_buf_size);
  return undo_buf == NULL;
}

undo_store(data, sz)
     char *data;
{
  char *p;
  
  if (undo_ptr + sz >= undo_buf_size) {
    /* extend undo buffer */
    p = (char *)realloc(undo_buf, undo_ptr + sz);
    if (p == NULL)
      return 1;
    undo_buf = p;
    undo_buf_size = undo_ptr + sz;
  }
  memcpy(undo_buf+undo_ptr, data, sz);
  undo_ptr += sz;
  return 0;
}

undo_mark()
{
  UNDOST u;
  
  u.cmd = UNDO_MARK;
  u.size = sizeof(u);
  undo_store(&u, sizeof(u));
}

undo_undo()
{
}

/* End of file */
